"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CardListingContainer = void 0;
var react_1 = __importStar(require("react"));
var PageError_1 = require("../../../PageError");
var PageListingNotFound_1 = require("../../../PageListingNotFound");
var Pagination_1 = require("../../../Pagination");
var PageListingContext_1 = require("../PageListingContext");
var S = __importStar(require("./CardListingContainer.style"));
function CardListingContainer() {
    var context = react_1.useContext(PageListingContext_1.PageListingContext);
    return react_1.default.createElement(CardListingContainerMainComponent, __assign({}, context));
}
exports.CardListingContainer = CardListingContainer;
var CardListingContainerMainComponent = function FiltersComponent(props) {
    var resources = props.resources, renderResource = props.renderResource, renderResourceSkeleton = props.renderResourceSkeleton, skeletonResources = props.skeletonResources, resourcesTotal = props.resourcesTotal, currentPage = props.currentPage, changePage = props.changePage, showCardsSkeleton = props.showCardsSkeleton, showCards = props.showCards, errorLoadData = props.errorLoadData, reloadPage = props.reloadPage;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(CardListingContainerComponent, { resources: resources, renderResource: renderResource, resourcesTotal: resourcesTotal, currentPage: currentPage, skeletonResources: skeletonResources, renderResourceSkeleton: renderResourceSkeleton, changePage: changePage, showCardsSkeleton: showCardsSkeleton, showCards: showCards, errorLoadData: errorLoadData, reloadPage: reloadPage })));
};
var CardListingContainerComponent = function FiltersDesktop(props) {
    var showCards = props.showCards, showCardsSkeleton = props.showCardsSkeleton, errorLoadData = props.errorLoadData, resources = props.resources, renderResource = props.renderResource, resourcesTotal = props.resourcesTotal, skeletonResources = props.skeletonResources, renderResourceSkeleton = props.renderResourceSkeleton, currentPage = props.currentPage, changePage = props.changePage, reloadPage = props.reloadPage;
    return (react_1.default.createElement(S.CardListingContainerStyle, null,
        react_1.default.createElement("div", { className: "cards-listing" },
            errorLoadData && react_1.default.createElement(PageError_1.PageError, { retry: reloadPage, fullscreen: true }),
            showCards &&
                !!resourcesTotal &&
                resources.map(function (resource, i) { return (react_1.default.createElement("span", { key: "card-" + resource.id, "data-testid": "card-" + resource.id }, renderResource(resource, i))); }),
            showCards && !resourcesTotal && react_1.default.createElement(PageListingNotFound_1.PageListingNotFound, null),
            react_1.default.createElement("div", { className: "cards-listing-skeleton" }, showCardsSkeleton &&
                skeletonResources.map(function (resource, i) { return (react_1.default.createElement("span", { key: "card-skeleton-" + i, "data-testid": "skeleton-card" }, renderResourceSkeleton(resource, i))); })),
            react_1.default.createElement("div", { className: "pagination-listing" },
                react_1.default.createElement(Pagination_1.Pagination, { total: resourcesTotal, perPage: 20, currentPage: currentPage, onChange: changePage })))));
};
//# sourceMappingURL=CardListingContainer.js.map