import React from 'react';
import { IViewList } from '@devesharp/react-hooks';
import { IPropsTabs } from '../../Tabs';
import { IPropsTagFilter } from '../../TagsFilters';

export type IFilterComponent<T = any> = React.FunctionComponent<{
   handleFilters: (v: () => T) => void;
   filters: T;
}>;

export interface IPageListingProps {
   title: string;
   viewList: IViewList;
   FiltersComponent: IFilterComponent;
   tabs?: IPropsTabs;
   limit?: number;
   tagsFilters?: Partial<IPropsTagFilter>;
   sortOptions?: {
      name: any;
      value: any;
   }[];
   renderResource: (resource: any, index: number) => JSX.Element;
   renderResourceSkeleton?: (resource: any, index: number) => JSX.Element;
}

export interface IPageListingChildrenProps extends IViewList {
   FiltersComponent: IFilterComponent;
   handleFilters: any;
   clearFilters: any;
   title: string;
   tabs: IPropsTabs;
   pageCountStart: number;
   pageCountEnd: number;
   sortOptions?: {
      name: any;
      value: any;
   }[];
   showCountListing: boolean;
   formSortRef: any;
   tagsFilters?: IPropsTagFilter;
   tagsFiltersRef: any;
   currentPage: number;
   changePage: any;
}
